Index: /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/iom_cdf.f90
===================================================================
--- /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/iom_cdf.f90	(revision 5599)
+++ /branches/2014/dev_r4650_UKMO14.12_STAND_ALONE_OBSOPER/NEMOGCM/TOOLS/SIREN/src/iom_cdf.f90	(revision 5600)
@@ -992,5 +868,4 @@
 
    END FUNCTION iom_cdf__read_att_name
-   !> @endcode   
    !-------------------------------------------------------------------
    !> @brief This function read variable or global attribute in an opened 
@@ -998,13 +873,12 @@
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file structure
-   !> @param[in] id_varid : variable id. use NF90_GLOBAL to read global 
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_file   file structure
+   !> @param[in] id_varid  variable id. use NF90_GLOBAL to read global 
    !> attribute in a file
-   !> @param[in] id_attid : attribute id
+   !> @param[in] id_attid  attribute id
    !> @return  attribute structure 
    !-------------------------------------------------------------------
-   !> @code
    TYPE(TATT) FUNCTION iom_cdf__read_att_id(td_file, id_varid, id_attid)
       IMPLICIT NONE
@@ -1022,7 +896,7 @@
 
          CALL logger_error( &
-         &  " READ ATT: no id associated to file "//TRIM(td_file%c_name))
-
-      ELSE      
+         &  "IOM CDF READ ATT: no id associated to file "//TRIM(td_file%c_name))
+
+      ELSE
 
          ! get attribute name
@@ -1036,22 +910,21 @@
 
    END FUNCTION iom_cdf__read_att_id
-   !> @endcode   
    !-------------------------------------------------------------------
    !> @brief This function read variable value in an opened 
-   !> netcdf file, given variable id.</br/>
-   !> start indices and number of indices selected along each dimension 
-   !> could be specify in a 4 dimension table (/'x','y','z','t'/)
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file structure
-   !> @param[in] id_varid : variable id
-   !> @param[in] id_start : index in the variable from which the data values 
+   !> netcdf file, given variable id.
+   !> @details
+   !> Optionaly, start indices and number of indices selected along each dimension 
+   !> could be specify in a 4 dimension array (/'x','y','z','t'/)
+   !
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_file   file structure
+   !> @param[in] id_varid  variable id
+   !> @param[in] id_start  index in the variable from which the data values 
    !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
+   !> @param[in] id_count  number of indices selected along each dimension
    !> @return  variable structure 
    !-------------------------------------------------------------------
-   !> @code
    TYPE(TVAR) FUNCTION iom_cdf__read_var_id(td_file, id_varid,&
    &                                        id_start, id_count)
@@ -1070,15 +943,14 @@
 
          CALL logger_error( &
-         &  " IOM READ VAR: no id associated to file "//TRIM(td_file%c_name))
+         &  " IOM CDF READ VAR: no id associated to file "//TRIM(td_file%c_name))
 
       ELSE
 
-         ! look for variable id
+         ! look for variable index
          il_ind(:)=MINLOC(td_file%t_var(:)%i_id,mask=(td_file%t_var(:)%i_id==id_varid))
          IF( il_ind(1) /= 0 )THEN
 
-            iom_cdf__read_var_id=td_file%t_var(il_ind(1))
-
-            print *,"iom_cdf__read_var_id ",trim(iom_cdf__read_var_id%c_name)," ",iom_cdf__read_var_id%i_ew
+            iom_cdf__read_var_id=var_copy(td_file%t_var(il_ind(1)))
+
             !!! read variable value
             CALL iom_cdf__read_var_value(td_file, iom_cdf__read_var_id, &
@@ -1086,7 +958,6 @@
 
          ELSE
-            print *,"iom_cdf__read_var_id "
             CALL logger_error( &
-            &  " IOM READ VAR: there is no variable with id "//&
+            &  " IOM CDF READ VAR: there is no variable with id "//&
             &  TRIM(fct_str(id_varid))//" in file "//TRIM(td_file%c_name))
          ENDIF
@@ -1094,27 +965,23 @@
       ENDIF
    END FUNCTION iom_cdf__read_var_id
-   !> @endcode   
    !-------------------------------------------------------------------
    !> @brief This function read variable value in an opened 
-   !> netcdf file, given variable name or standard name.</br/>
-   !> start indices and number of indices selected along each dimension 
-   !> could be specify in a 4 dimension table (/'x','y','z','t'/)
-   !
+   !> netcdf file, given variable name or standard name.
    !> @details
+   !> Optionaly, start indices and number of indices selected along each dimension 
+   !> could be specify in a 4 dimension array (/'x','y','z','t'/)
+   !>
    !> look first for variable name. If it doesn't
    !> exist in file, look for variable standard name.<br/>
-   !> If variable name is not present, check variable standard name.<br/>
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file structure
-   !> @param[in] cd_name  : variable name
-   !> @param[in] id_start : index in the variable from which the data values will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !> @param[in] cd_stdname : variable standard name
+   !
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_file   file structure
+   !> @param[in] cd_name   variable name or standard name.
+   !> @param[in] id_start  index in the variable from which the data values will be read
+   !> @param[in] id_count  number of indices selected along each dimension
    !> @return  variable structure 
    !-------------------------------------------------------------------
-   !> @code
    TYPE(TVAR) FUNCTION iom_cdf__read_var_name(td_file, cd_name,  &
    &                                          id_start, id_count )
@@ -1127,5 +994,5 @@
 
       ! local variable
-      INTEGER(i4)       :: il_ind
+      INTEGER(i4)       :: il_varid
       !----------------------------------------------------------------
       ! check if file opened
@@ -1133,5 +1000,5 @@
 
          CALL logger_error( &
-         &  " IOM READ VAR: no id associated to file "//TRIM(td_file%c_name))
+         &  " IOM CDF READ VAR: no id associated to file "//TRIM(td_file%c_name))
 
       ELSE
@@ -1140,13 +1007,13 @@
 
             CALL logger_error( &
-            &  " IOM READ VAR: you must specify a variable to read "//&
+            &  " IOM CDF READ VAR: you must specify a variable to read "//&
             &  " in file "//TRIM(td_file%c_name))
 
          ELSE
 
-            il_ind=var_get_id(td_file%t_var(:), cd_name)
-            IF( il_ind /= 0 )THEN
-
-               iom_cdf__read_var_name=td_file%t_var(il_ind)
+            il_varid=var_get_index(td_file%t_var(:), cd_name)
+            IF( il_varid /= 0 )THEN
+
+               iom_cdf__read_var_name=var_copy(td_file%t_var(il_varid))
 
                !!! read variable value
@@ -1158,5 +1025,5 @@
 
                CALL logger_error( &
-               &  " IOM READ VAR: there is no variable with "//&
+               &  " IOM CDF READ VAR: there is no variable with "//&
                &  " name or standard name "//TRIM(cd_name)//&
                &  " in file "//TRIM(td_file%c_name) )
@@ -1168,23 +1035,19 @@
       
    END FUNCTION iom_cdf__read_var_name
-   !> @endcode
-   !-------------------------------------------------------------------
-   !> @brief This subroutine fill variable value in an opened 
-   !> netcdf file, given variable id.</br/>
-   !> start indices and number of indices selected along each dimension 
-   !> could be specify in a 4 dimension table (/'x','y','z','t'/)
-   !
-   !> @note ne peut pas marcher qd on fait boucle sur les variable d'un
-   !> fichier. puisque change id.
-
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @param[in] id_start : index in the variable from which the data values 
+   !-------------------------------------------------------------------
+   !> @brief This subroutine fill all variable value from an opened 
+   !> netcdf file.
+   !> @details
+   !> Optionaly, start indices and number of indices selected along each dimension 
+   !> could be specify in a 4 dimension array (/'x','y','z','t'/)
+   !
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !> @param[in] id_start     index in the variable from which the data values 
    !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !-------------------------------------------------------------------
-   !> @code
+   !> @param[in] id_count     number of indices selected along each dimension
+   !-------------------------------------------------------------------
    SUBROUTINE iom_cdf__fill_var_all(td_file, id_start, id_count)
       IMPLICIT NONE
@@ -1203,34 +1066,31 @@
 
          CALL logger_error( &
-         &  " FILL VAR: no id associated to file "//TRIM(td_file%c_name))
+         &  " IOM CDF FILL VAR: no id associated to file "//TRIM(td_file%c_name))
 
       ELSE
 
          DO ji=1,td_file%i_nvar
-            CALL iom_cdf_fill_var(td_file, ji, id_start, id_count)
+            CALL iom_cdf_fill_var(td_file, td_file%t_var(ji)%i_id, &
+            &                     id_start, id_count)
          ENDDO
 
       ENDIF
    END SUBROUTINE iom_cdf__fill_var_all
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine fill variable value in an opened 
-   !> netcdf file, given variable id.</br/>
-   !> start indices and number of indices selected along each dimension 
-   !> could be specify in a 4 dimension table (/'x','y','z','t'/)
-   !
-   !> @note ne peut pas marcher qd on fait boucle sur les variable d'un
-   !> fichier. puisque change id.
-
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @param[in] id_varid : variable id
-   !> @param[in] id_start : index in the variable from which the data values 
+   !> netcdf file, given variable id.
+   !> @details
+   !> Optionaly, start indices and number of indices selected along each dimension 
+   !> could be specify in a 4 dimension array (/'x','y','z','t'/)
+   !
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !> @param[in] id_varid     variable id
+   !> @param[in] id_start     index in the variable from which the data values 
    !> will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !-------------------------------------------------------------------
-   !> @code
+   !> @param[in] id_count     number of indices selected along each dimension
+   !-------------------------------------------------------------------
    SUBROUTINE iom_cdf__fill_var_id(td_file, id_varid, id_start, id_count)
       IMPLICIT NONE
@@ -1242,5 +1102,5 @@
 
       ! local variable
-      INTEGER(i4), DIMENSION(1) :: il_ind
+      INTEGER(i4), DIMENSION(1) :: il_varid
 
       ! loop indices
@@ -1251,23 +1111,25 @@
 
          CALL logger_error( &
-         &  " FILL VAR: no id associated to file "//TRIM(td_file%c_name))
+         &  "IOM CDF FILL VAR: no id associated to file "//TRIM(td_file%c_name))
 
       ELSE
 
          ! look for variable id
-         il_ind(:)=MINLOC( td_file%t_var(:)%i_id, &
+         il_varid(:)=MINLOC( td_file%t_var(:)%i_id, &
          &                 mask=(td_file%t_var(:)%i_id==id_varid))
-         IF( il_ind(1) /= 0 )THEN
+         IF( il_varid(1) /= 0 )THEN
 
             !!! read variable value
-            CALL iom_cdf__read_var_value(td_file, td_file%t_var(il_ind(1)), &
+            CALL iom_cdf__read_var_value(td_file, td_file%t_var(il_varid(1)), &
             &                            id_start, id_count)
 
             DO ji=1,td_file%i_nvar
-               CALL logger_debug(" var id "//TRIM(td_file%t_var(ji)%c_name)//" "//TRIM(fct_str(td_file%t_var(ji)%i_id)) )
+               CALL logger_debug(" IOM CDF FILL VAR: var id "//&
+               &     TRIM(td_file%t_var(ji)%c_name)//" "//&
+               &     TRIM(fct_str(td_file%t_var(ji)%i_id)) )
             ENDDO
          ELSE
             CALL logger_error( &
-            &  " FILL VAR: there is no variable with id "//&
+            &  " IOM CDF FILL VAR: there is no variable with id "//&
             &  TRIM(fct_str(id_varid))//" in file "//TRIM(td_file%c_name))
          ENDIF
@@ -1275,25 +1137,22 @@
       ENDIF
    END SUBROUTINE iom_cdf__fill_var_id
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine fill variable value in an opened 
-   !> netcdf file, given variable name or standard name.</br/>
-   !> start indices and number of indices selected along each dimension 
-   !> could be specify in a 4 dimension table (/'x','y','z','t'/)
-   !
+   !> netcdf file, given variable name or standard name.
    !> @details
+   !> Optionaly, start indices and number of indices selected along each dimension 
+   !> could be specify in a 4 dimension array (/'x','y','z','t'/)
+   !>
    !> look first for variable name. If it doesn't
    !> exist in file, look for variable standard name.<br/>
-   !> If variable name is not present, check variable standard name.<br/>
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @param[in] cd_name  : variable name or standard name
-   !> @param[in] id_start : index in the variable from which the data values will be read
-   !> @param[in] id_count : number of indices selected along each dimension
-   !-------------------------------------------------------------------
-   !> @code
+   !
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[inout] td_file   file structure
+   !> @param[in] cd_name      variable name or standard name
+   !> @param[in] id_start     index in the variable from which the data values will be read
+   !> @param[in] id_count     number of indices selected along each dimension
+   !-------------------------------------------------------------------
    SUBROUTINE iom_cdf__fill_var_name(td_file, cd_name, id_start, id_count )
       IMPLICIT NONE
@@ -1305,5 +1164,5 @@
 
       ! local variable
-      INTEGER(i4)       :: il_ind
+      INTEGER(i4)       :: il_varid
       !----------------------------------------------------------------
       ! check if file opened
@@ -1311,13 +1170,13 @@
 
          CALL logger_error( &
-         &  " FILL VAR: no id associated to file "//TRIM(td_file%c_name))
+         &  "IOM CDF FILL VAR: no id associated to file "//TRIM(td_file%c_name))
 
       ELSE
 
-            il_ind=var_get_id(td_file%t_var(:), cd_name)
-            IF( il_ind /= 0 )THEN
+            il_varid=var_get_index(td_file%t_var(:), cd_name)
+            IF( il_varid /= 0 )THEN
 
                !!! read variable value
-               CALL iom_cdf__read_var_value(td_file, td_file%t_var(il_ind), &
+               CALL iom_cdf__read_var_value(td_file, td_file%t_var(il_varid), &
                &                            id_start, id_count)
 
@@ -1325,5 +1184,5 @@
 
                CALL logger_error( &
-               &  " FILL VAR: there is no variable with "//&
+               &  "IOM CDF FILL VAR: there is no variable with "//&
                &  "name or standard name"//TRIM(cd_name)//&
                &  " in file "//TRIM(td_file%c_name))
@@ -1333,19 +1192,19 @@
       
    END SUBROUTINE iom_cdf__fill_var_name
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This function read metadata of a variable in an opened 
-   !> netcdf file.</br/>
+   !> netcdf file.
    !
    !> @note variable value are not read
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] id_fileid : file id
-   !> @param[in] id_varid : variable id
+   !> - November, 2013- Initial Version
+   !> @date September, 2014
+   !> - force to use FillValue=1.e20 if no FillValue for coordinate variable.
+   !
+   !> @param[in] td_file   file structure
+   !> @param[in] id_varid  variable id
    !> @return  variable structure 
    !-------------------------------------------------------------------
-   !> @code
    TYPE(TVAR) FUNCTION iom_cdf__read_var_meta(td_file, id_varid)
       IMPLICIT NONE
@@ -1375,5 +1234,6 @@
 
          CALL logger_error( &
-         &  " READ ATT: no id associated to file "//TRIM(td_file%c_name))
+         &  " IOM CDF READ VAR META: no id associated to file "//&
+         &   TRIM(td_file%c_name))
 
       ELSE
@@ -1381,5 +1241,6 @@
          ! inquire variable
          CALL logger_trace( &
-         &  " READ VAR: inquire variable "//TRIM(fct_str(id_varid))//&
+         &  " IOM CDF READ VAR META: inquire variable "//&
+         &  TRIM(fct_str(id_varid))//&
          &  " in file "//TRIM(td_file%c_name))
          
@@ -1393,8 +1254,6 @@
          &                                il_natt )
          CALL iom_cdf__check(il_status)
-
          !!! fill variable dimension structure
          tl_dim(:)=iom_cdf__read_var_dim( td_file, il_ndim, il_dimid(:) )
-
          IF( il_natt /= 0 )THEN
             ALLOCATE( tl_att(il_natt) )
@@ -1405,5 +1264,5 @@
             il_attid=att_get_id(tl_att(:),'_FillValue')
             IF( il_attid == 0 )THEN
-               CALL logger_warn("IOM READ VAR: no _FillValue for variable "//&
+               CALL logger_info("IOM CDF READ VAR META: no _FillValue for variable "//&
                &  TRIM(cl_name)//" in file "//TRIM(td_file%c_name) )
 
@@ -1411,27 +1270,39 @@
                IF( il_attid /= 0 )THEN
                   ! create attribute _FillValue
-                  CALL logger_warn("IOM READ VAR: assume _FillValue is equal to "//&
+                  CALL logger_info("IOM CDF READ VAR META: assume _FillValue is equal to "//&
                   &                "missing_value for variable "//TRIM(cl_name) )
-                  tl_fill=att_init('_FillValue',tl_att(il_attid)%d_value(:))
+                  tl_fill=att_init('_FillValue',tl_att(il_attid)%d_value(:), &
+                  &                 id_type=tl_att(il_attid)%i_type)
                ELSE
                   ! create attribute _FillValue
-                  CALL logger_warn("IOM READ VAR: assume _FillValue is equal to "//&
-                  &                "zero for variable "//TRIM(cl_name) )
-                  tl_fill=att_init('_FillValue',0.)
-                  !tl_fill=att_init('_FillValue',1.e20)
+                  SELECT CASE(TRIM(cl_name))
+                     CASE DEFAULT
+                        CALL logger_info("IOM CDF READ VAR META: assume _FillValue is equal to "//&
+                        &                "zero for variable "//TRIM(cl_name) )
+                        tl_fill=att_init('_FillValue',0.)
+                     CASE('nav_lon','nav_lat', &
+                        &  'glamt','glamu','glamv','glamf', &
+                        &  'gphit','gphiu','gphiv','gphif')
+                        CALL logger_info("IOM CDF READ VAR META: assume _FillValue is equal to "//&
+                        &                "dummy fillValue (1.e20) for variable "//TRIM(cl_name) )
+                        tl_fill=att_init('_FillValue',1.e20)
+                  END SELECT
                ENDIF
 
                ALLOCATE( tl_tmp(il_natt) )
                ! save read attribut
-               tl_tmp(:)=tl_att(:)
-               ! change number of attribute in table
+               tl_tmp(:)=att_copy(tl_att(:))
+               ! change number of attribute in array
+               CALL att_clean(tl_att(:))
                DEALLOCATE( tl_att )
                ALLOCATE( tl_att(il_natt+1) )
                ! copy read attribut
-               tl_att(1:il_natt)=tl_tmp(:)
+               tl_att(1:il_natt)=att_copy(tl_tmp(:))
+               ! clean
+               CALL att_clean(tl_tmp(:))
                DEALLOCATE( tl_tmp )
 
                ! create attribute _FillValue
-               tl_att(il_natt+1)=tl_fill
+               tl_att(il_natt+1)=att_copy(tl_fill)
 
             ENDIF
@@ -1440,9 +1311,18 @@
             ALLOCATE(tl_att(il_natt+1) )
             ! create attribute _FillValue
-            CALL logger_warn("IOM READ VAR: assume _FillValue is equal to "//&
-            &                "zero for variable "//TRIM(cl_name) )
-            tl_fill=att_init('_FillValue',0.)
+            SELECT CASE(TRIM(cl_name))
+               CASE DEFAULT
+                  CALL logger_info("IOM CDF READ VAR META: assume _FillValue is equal to "//&
+                  &                "zero for variable "//TRIM(cl_name) )
+                  tl_fill=att_init('_FillValue',0.)
+               CASE('nav_lon','nav_lat', &
+                  &  'glamt','glamu','glamv','glamf', &
+                  &  'gphit','gphiu','gphiv','gphif')
+                  CALL logger_info("IOM CDF READ VAR META: assume _FillValue is equal to "//&
+                  &                "dummy fillValue (1.e20) for variable "//TRIM(cl_name) )
+                  tl_fill=att_init('_FillValue',1.e20)
+            END SELECT            
             ! create attribute _FillValue
-            tl_att(il_natt+1)=tl_fill
+            tl_att(il_natt+1)=att_copy(tl_fill)
          ENDIF
 
@@ -1451,4 +1331,8 @@
          &                                tl_att(:), id_id=id_varid )
 
+         ! clean
+         CALL dim_clean(tl_dim(:))
+         CALL att_clean(tl_fill)
+         CALL att_clean(tl_att(:))
          DEALLOCATE( tl_att )
 
@@ -1456,24 +1340,24 @@
 
    END FUNCTION iom_cdf__read_var_meta
-   !> @endcode
    !-------------------------------------------------------------------
    !> @brief This subroutine read variable dimension
    !> in an opened netcdf file.
-   !
+   !>
    !> @details
    !> the number of dimension can't exceed 4, 
    !> and should be 'x', 'y', 'z', 't' (whatever their order).<br/>
-   !> If the number of dimension read is less than 4, the table of dimension
+   !> If the number of dimension read is less than 4, the array of dimension
    !> strucure is filled with unused dimension.<br/>
-   !> So the table of dimension structure of a variable is always compose of 4
+   !> So the array of dimension structure of a variable is always compose of 4
    !> dimension (use or not). 
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[inout] td_file : file structure
-   !> @return file structure completed 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_file   file structure
+   !> @param[in] id_ndim   number of dimension
+   !> @param[in] id_dimid  array of dimension id
+   !> @return array dimension structure 
+   !-------------------------------------------------------------------
    FUNCTION iom_cdf__read_var_dim(td_file, id_ndim, id_dimid)
       IMPLICIT NONE
@@ -1502,5 +1386,8 @@
          CALL dim_reorder(tl_dim(:))
 
-         iom_cdf__read_var_dim(:)=tl_dim(:)
+         iom_cdf__read_var_dim(:)=dim_copy(tl_dim(:))
+
+         ! clean
+         CALL dim_clean(tl_dim(:))
 
       ELSE IF( id_ndim > 0 .AND. id_ndim <= 4 )THEN
@@ -1508,5 +1395,5 @@
 
          DO ji = 1, id_ndim
-            CALL logger_debug( " READ VAR DIM: get variable dimension "//&
+            CALL logger_trace( " IOM CDF READ VAR DIM: get variable dimension "//&
             &               TRIM(fct_str(ji)) )
 
@@ -1521,9 +1408,12 @@
          CALL dim_reorder(tl_dim(:))
       
-         iom_cdf__read_var_dim(:)=tl_dim(:)
+         iom_cdf__read_var_dim(:)=dim_copy(tl_dim(:))
+
+         ! clean
+         CALL dim_clean(tl_dim(:))
 
       ELSE
 
-         CALL logger_error(" READ VAR DIM: can't manage "//&
+         CALL logger_error(" IOM CDF READ VAR DIM: can't manage "//&
          &              TRIM(fct_str(id_ndim))//" dimension(s)" )
 
@@ -1531,5 +1421,4 @@
 
    END FUNCTION iom_cdf__read_var_dim
-   !> @endcode   
    !-------------------------------------------------------------------
    !> @brief This subroutine read variable attributes
@@ -1537,11 +1426,11 @@
    !
    !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file structure
-   !> @param[inout] td_var : variable structure
-   !> @return filled variable attribute structure 
-   !-------------------------------------------------------------------
-   !> @code
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_file   file structure
+   !> @param[in] id_varid  variable id
+   !> @param[in] id_natt   number of attributes
+   !> @return array of attribute structure
+   !-------------------------------------------------------------------
    FUNCTION iom_cdf__read_var_att(td_file, id_varid, id_natt)
       IMPLICIT NONE
@@ -1555,5 +1444,4 @@
 
       ! local variable
-      TYPE(TATT), DIMENSION(id_natt) :: tl_att
 
       ! loop indices
@@ -1562,35 +1450,35 @@
 
       IF( id_natt > 0 )THEN
-
+      
          ! read attributes
          DO ji = 1, id_natt
-            CALL logger_debug( " READ VAR ATT: get attribute "//&
+            CALL logger_trace( " IOM CDF READ VAR ATT: get attribute "//&
             &               TRIM(fct_str(ji)) )
 
-            tl_att(ji)=iom_cdf_read_att(td_file, id_varid, ji)
+            iom_cdf__read_var_att(ji)=iom_cdf_read_att(td_file, id_varid, ji)
 
          ENDDO
 
-         iom_cdf__read_var_att(:)=tl_att(:)
-
       ELSE
 
-         CALL logger_debug( " READ VAR ATT: no attribute for variable " )
+         CALL logger_debug( " IOM CDF READ VAR ATT: no attribute for variable " )
 
       ENDIF
 
    END FUNCTION iom_cdf__read_var_att
-   !> @endcode   
    !-------------------------------------------------------------------
    !> @brief This subroutine read variable value
    !> in an opened netcdf file.
-   !
-   !> @author J.Paul
-   !> - Nov, 2013- Initial Version
-   !
-   !> @param[in] td_file : file structure
-   !> @param[inout] td_var : variable structure
-   !> @param[in] id_start : index in the variable from which the data values will be read
-   !> @param[in] id_count : number of indices selected along each dimension
+   !> @details
+   !> Optionaly, start indices and number of indices selected along each dimension 
+   !> could be specify in a 4 dimension array (/'x','y','z','t'/)
+   !
+   !> @author J.Paul
+   !> - November, 2013- Initial Version
+   !
+   !> @param[in] td_file   file structure
+   !> @param[inout] td_var variable structure
+   !> @param[in] id_start  index in the variable from which the data values will be read
+   !> @param[in] id_count  number of indices selected along each dimension
    !> @return variable structure completed 
    !
@@ -1598,5 +1486,4 @@
    !> - warning do not change fill value when use scale factor..
    !-------------------------------------------------------------------
-   !> @code
    SUBROUTINE iom_cdf__read_var_value(td_file, td_var, &
    &                                  id_start, id_count )
